﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp.ChartTools
{
    public partial class FormCurvePlotter : Form
    {
        FormMain meinMain;

        public FormCurvePlotter(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        public string leg;

        double amp = 0;
        public double Xmax = 0;

        public double function(double x)
        {
            double y = 0;
            meinMain.ConvertToDouble(tBPar1.Text, ref Xmax);
            meinMain.ConvertToDouble(tBpar2.Text, ref amp);

            if (radioButtonExp.Checked)
            {
                //y = amp*(1 - Math.Exp(-2.0 * x));
                //leg = "1-exp(-2x)";
                y = 0.5 * (1 +4.50 * Math.Exp(-0.2 * x) * Math.Sin(1.7777 * x - 12.84 * Math.PI / 180.0));
                leg = "Bay77T2";
            }
            if (radioButtonCos.Checked)
            {
                y = amp*(Math.Cos(x ));
                leg = "Cosinus";

            }
            if (radioButtonSin.Checked)
            {
                y = amp*(Math.Sin(x ));
                leg = "Sinus";
            }
            if (rB4.Checked)
            {  //weg mit konstanter Beschleunigung amp, nach der Hälfte konstante Bremsung
                if (x < Xmax/2.0)
                    y = amp * x * x;
                else
                    y = -amp * (Xmax * Xmax / 2 - 2 * x * Xmax + x * x);
            }
            return (y);

        }

        private void FormCurvePlotter_FormClosing(object sender, FormClosingEventArgs e)
        {
        }
    }
}
