﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MPS;
using System.Runtime.InteropServices;
using System.Diagnostics;
using WINDF7CSharp;

namespace CraneModelMuk
{
    public partial class FormCraneModelMuk : Form
    {

        TMultimediaTimer MMTimer1;
        FormMain meinMain;
        double cPendxrmin, cPendxrmax;
        double cpendt0 = 0.001;
        double cxda, cxda1, PendelVSoll, cxdm, cxdm1, DeltAlpha, wagposist, wagpossoll;
        double cdxrmax, cdxrmax1s, cq0ax, cq1ax, cq0mx, cq1mx, cpendposx;
        double cpendposxold, cxsoll, PendelV;

        //double cdxrw, cdkx, cdtn, cdkr, cxtdm, cytdm, cxkrm, cykrm, ctna;
        
        double cxinV;
        bool crun = false, cStart = false;
        double cpendpospt1;
        double Pend6Uhr; 
        double Pend12Uhr;  
        double cPendymax = 9.9, cPendymin = -9.9;
        double winkel;

        Stopwatch stopwatch1;
        Graphics gPB; Pen p,pbridge; Point p1, p2,pointPendTop,pointPendBottom;
       
        int paintxold, paintyold;
        SolidBrush pbrush;


        public FormCraneModelMuk(FormMain m)
        {
            InitializeComponent();
            MMTimer1 = new TMultimediaTimer(null);
            MMTimer1.Interval = 6;
            MMTimer1.OnTimer = onMMTimer1;
            stopwatch1 = new Stopwatch();
            p = new Pen(Color.Red,2);
            stopwatch1.Start();
            meinMain = m;
            gPB = Graphics.FromHwnd(pictureBox1.Handle);
            pictureBox1.BackColor=Color.SkyBlue;
            p1 = new Point(50, 20); p2 = new Point(350, 20);
            pbridge = new Pen(Color.Green, 3); pbrush = new SolidBrush(Color.Orange);
        }

        private void FormCraneModelMuk_FormClosing(object sender, FormClosingEventArgs e)
        {
            MMTimer1.Disable();
            e.Cancel = true;
            this.Visible = false;
        }


       
        double calpha;
        int cxycnt2 = 0;
       
        double KpPreg = 22.0;     
       
        int reccnt = 0;
        double recampl = 0, Amplitude = 2;
        double t0start = 0, t0end = 0; double dtstart = 0, dtend = 0; double dtmax = 0; double t0 = 0, dt = 0;
        double KPD,KPI;

        void onMMTimer1(TMultimediaTimer Sender)
        {
           double fakWegProWinkel=1.0/0.18;

           t0end = t0start;
           t0start = stopwatch1.ElapsedTicks;
           t0 = (t0start - t0end) / (float)Stopwatch.Frequency * 1000;
           double posxd;

           if (crun)
           {
               dtstart = stopwatch1.ElapsedTicks;
              
               cxycnt2++; reccnt++;

               //time counter ,each time timer reachs a certain value, recampl will change
               if (reccnt == 800) recampl = Amplitude;
               if (reccnt == 1600) { recampl = -Amplitude; reccnt = 0; }

               if (rbZero.Checked)
               {
                   wagposist=cinputx();                     

                   wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   coutputx(KpPreg * posxd);

               }

               if (rbWithoutDamping.Checked)
               {
                   wagposist=cinputx();                      

                   if (cStart) wagpossoll = recampl;        
                   else wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   
                   coutputx(KpPreg * posxd);

               }

               if (rbWithDamping.Checked)
               {
                   cxinV=cinputy(); calpha = cxinV - Pend6Uhr;    
                   wagposist=cinputx();                      
                   cpendposx = wagposist + fakWegProWinkel * calpha;      
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;    
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);  
                   cpendposxold = cpendpospt1;

                   cxsoll = recampl;
                   cxda = cxsoll - wagposist;                   
                   PendelVSoll = 0.84 * cxda;

                   cxdm = PendelVSoll - PendelV;
                   DeltAlpha = 1.57 * cxdm - 1.2 * cxdm1;        
                   cxdm1 = cxdm;
                   if (DeltAlpha >= cPendxrmax) DeltAlpha = cPendxrmax;    
                   if (DeltAlpha <= -cPendxrmax) DeltAlpha = -cPendxrmax;

                   wagpossoll = cpendposx + DeltAlpha;           
                   if (wagpossoll >= cPendxrmax) wagpossoll = cPendxrmax;    
                   if (wagpossoll <= cPendxrmin) wagpossoll = cPendxrmin;

                  
                   if (cStart==false) wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   
                   coutputx(KpPreg * posxd); 

               }

               if (rbFixedDamped.Checked)       
               {
                   cxinV=cinputy(); calpha = cxinV - Pend6Uhr;   
                   wagposist=cinputx();                      

                   cpendposx = wagposist + fakWegProWinkel * calpha;      
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;    
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);  
                   cpendposxold = cpendpospt1;

                   cxsoll = 0;
                   cxda = cxsoll - wagposist;                  
                   PendelVSoll = 0.84 * cxda;

                   cxdm = PendelVSoll - PendelV;
                   DeltAlpha = 1.57 * cxdm - 1.2 * cxdm1;        
                   cxdm1 = cxdm;
                   if (DeltAlpha >= cPendxrmax) DeltAlpha = cPendxrmax;    
                   if (DeltAlpha <= -cPendxrmax) DeltAlpha = -cPendxrmax;

                   wagpossoll = cpendposx + DeltAlpha;           
                   if (wagpossoll >= cPendxrmax) wagpossoll = cPendxrmax;   
                   if (wagpossoll <= cPendxrmin) wagpossoll = cPendxrmin;

                   
                   if (cStart==false) wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   coutputx(KpPreg * posxd); 
                  

               }
               if (rbAutoscillation.Checked)
               {
                   double outwert = 0;
                   cxinV=cinputy(); calpha = cxinV - Pend6Uhr;   
                   wagposist=cinputx();                      
                   cpendposx = -fakWegProWinkel * calpha;     
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;   
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);
                   cpendposxold = cpendpospt1;
                   if (cStart)
                       if ((calpha < 2) && (calpha > -3))
                       {
                           outwert = PendelV;
                           coutputx(outwert);
                       }
                       else if ((Math.Abs(cxinV - Pend12Uhr) < 0.1) && (cbAutomaticalStandUp.Checked))
                       {
                           rbStanding.Checked = true;
                       }
                       else    
                       {
                           posxd = 0 - wagposist;
                           coutputx(2 * posxd);
                       }


                   else coutputx(0);

               }
               if (rbStanding.Checked)
               {
                   KPD = trackBar2.Value / 100.0;
                   KPI = trackBar3.Value / 100.0;
                   cxinV=cinputy(); calpha = cxinV - Pend12Uhr;    
                   wagposist=cinputx();                

                   cpendposx = wagposist - fakWegProWinkel * calpha; 
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;   
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);  
                   cpendposxold = cpendpospt1;

                   if ((Math.Abs(calpha) < 0.4) && (Math.Abs(PendelV) < 2))
                   {
                       if (cbPositionGeneratorOn.Checked) cxsoll = recampl; else cxsoll = 0;
                       cxda = cxsoll - wagpossoll;
                       
                       PendelVSoll = PendelVSoll + cq0ax *KPI* cxda + cq1ax *KPI* cxda1;
                       cxda1 = cxda;

                       cxdm = PendelVSoll - PendelV;
                       
                       DeltAlpha = cq0mx * cxdm*KPD + cq1mx *KPD* cxdm1;    
                       cxdm1 = cxdm;
                       if (DeltAlpha >= cPendxrmax) DeltAlpha = cPendxrmax;    
                       if (DeltAlpha <= -cPendxrmax) DeltAlpha = -cPendxrmax;

                       wagpossoll = cpendposx - DeltAlpha;         
                       if (wagpossoll >= cPendxrmax) wagpossoll = cPendxrmax;    
                       if (wagpossoll <= cPendxrmin) wagpossoll = cPendxrmin;

                       
                       if (cStart==false) wagpossoll = 0;
                       posxd = wagpossoll - wagposist;
                       coutputx(KpPreg * posxd); 

                   }
                   else     
                   {
                       posxd = 0 - wagposist;
                       coutputx(2 * posxd);
                   }
               }

               if (rbPosHand.Checked)
               {
                   wagposist=cinputx();                      

                   if (cStart) wagpossoll = (double)((trackBar1.Value/ 10.0)*(-1));
                   else wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   coutputx(KpPreg * posxd);

               }

               dtend = stopwatch1.ElapsedTicks;
               dt = (dtend - dtstart) / Stopwatch.Frequency * 1000;
                  

           }
           else
           { cinit(); }

        }

        // input of position ,channel 0
        double cinputx() 
        {
            double val = 0;
            meinMain.ADCinput(0, ref val);
            return val;

        }

        //input of angel ,channel 1
        double cinputy() 
        {
            double val = 0;
            meinMain.ADCinput(1, ref val);
            return val;
        }

        //output of position, channel 0
        void coutputx(double y)
        {
            if (y >= cPendymax) y = cPendymax;
            if (y <= cPendymin) y = cPendymin;

            meinMain.DACoutput(0, y);
        }

        void cinit()
        {
                 Pend6Uhr=8.31; 
                 Pend12Uhr= 2.86;  
                 cPendxrmin = -10.0; cPendxrmax = 10.0; 
                
                 cdxrmax1s=100;
                 //cdxrw=0.01;cdkx=0.01;cdtn=0.01;cdkr=0.01;
                 
                 cpendt0=0.006;
                 cq0ax=0;cq1ax=0;
                 cxda=0;cxdm=0;cxdm1=0;cxda1=0;
                 DeltAlpha=0;wagpossoll=0;
                 cxsoll=0;cpendpospt1=0;PendelVSoll=0;
                 PendelV=0;
                 cpendposxold=0;
                 cq0mx=0;cq1mx=0;cq0ax=0;cq1ax=0;
         }

        private void buttonRestPos_Click(object sender, EventArgs e)
        {
            crun = false; 
            cStart = false;
            label6.Visible = false;
            labelT0.Visible = false;
            labeldT.Visible = false;
            labeldTMAX.Visible = false;
            rbStop.Checked=true;
            coutputx(-4);  
            cinit();
            timerDrawing.Enabled = true;
        }

        double sinfak;
        private void buttonStart_Click(object sender, EventArgs e)
        {
           
            label2.Visible = true;
            tbX.Visible = true;



            timerDisplay.Enabled = true;  
            label7.Visible = false;
            label6.Visible = false;
            cdxrmax=cdxrmax1s*cpendt0;

            trackBar1.Visible = false;
            labelT0.Visible = true;
            labeldT.Visible = true;
            labeldTMAX.Visible = true;
            double c=Pend6Uhr-Pend12Uhr; if (c==0) c=0.579 ; else c=Math.PI/c;
            sinfak=c;
            
            cStart=true;
            crun=true;
            MMTimer1.Enable();







        }

       

        private void buttonAccept12Clock_Click(object sender, EventArgs e)
        {
            label7.Text = "PLEASE SET THE PENDULUM AT 6 O'CLOCK";
            buttonAccept12Clock.Visible = false;
            winkel = cinputy();
            Pend12Uhr = winkel;
        }

        private void buttonAccept6Clock_Click(object sender, EventArgs e)
        {
            winkel = cinputy();
            Pend6Uhr = winkel;
            buttonAccept6Clock.Visible = false;
        }

        private void rbStop_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStop.Checked)
            {
                crun = false; //Stop
                cStart = false;
                label6.Visible = true;
                labelT0.Visible = false;
                labeldT.Visible = false;
                labeldTMAX.Visible = false;
                rbStop.PerformClick();
                coutputx(0);
                trackBar1.Visible = false;
                timerDisplay.Enabled = false;
                
            }
            

        }

        private void rbWithoutDamping_CheckedChanged(object sender, EventArgs e)
        {
            if (rbWithoutDamping.Checked)
            {
                buttonStart_Click(sender,e);
                 meinMain.ConvertToDouble(tbAmplitude.Text,ref Amplitude );
            }
            
        }

        private void rbWithDamping_CheckedChanged(object sender, EventArgs e)
        {
            if (rbWithDamping.Checked)
            {
                buttonStart_Click(sender, e);
                meinMain.ConvertToDouble(tbAmplitude.Text,ref Amplitude  );
            }
            
        }

        private void rbFixedDamped_CheckedChanged(object sender, EventArgs e)
        {
            if (rbFixedDamped.Checked)
            {
                buttonStart_Click(sender, e);
                PendelVSoll = 0;
                cq0mx = 0.20583 * 10; cq1mx = -0.15833 * 10;
                cq0ax = 0.4794 * 0.2; cq1ax = -0.4788 * 0.2;
            }
            
        }

        private void rbStanding_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStanding.Checked)
            {
                buttonStart_Click(sender, e);
                PendelVSoll = 0;
                cq0mx = 0.20583 * 10; cq1mx = -0.15833 * 10;
                cq0ax = 0.4794 * 0.2; cq1ax = -0.4788 * 0.2;
            }
            
        }

        private void rbAutoscillation_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAutoscillation.Checked)
            {
                buttonStart_Click(sender, e);
            }
            
        }

        private void rbZero_CheckedChanged(object sender, EventArgs e)
        {
            if (rbZero.Checked)
	        {
        		 label2.Visible=true;
                 buttonAccept12Clock.Visible=true;
                buttonAccept6Clock.Visible=true;
                tbX.Visible=true;
                timerDisplay.Enabled=true;
                cStart=false;   
                crun=true;
                MMTimer1.Enable();  
	        }
            else
            {
                buttonAccept12Clock.Visible = false;
                buttonAccept6Clock.Visible = false;
            }
            
        }

        private void rbPosHand_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPosHand.Checked)
            {
                buttonStart_Click(sender, e);
                trackBar1.Visible = true;


            }
            else
            {
                trackBar1.Visible = false;
            }
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            MMTimer1.Disable();
            
            this.Visible = false;
        }


        //timer displays T0,dT,dTMAX
        private void timerDisplay_Tick(object sender, EventArgs e)
        {
            labelT0.Text = t0.ToString("f2");
            labeldT.Text = dt.ToString("f2");
            if (dtmax<dt)
            {
                dtmax = dt;
            }
            labeldTMAX.Text = dtmax.ToString("f2");
            labTB2.Text = (KPD).ToString("f2");
            labTBPI.Text = (KPI).ToString("f2");

        }

        //timer draws graphic
        private void timerDrawing_Tick(object sender, EventArgs e)
        {
            gPB.Clear(Color.SkyBlue);
            int size = 12;
            
            double x = cinputy();


            double c = Pend6Uhr - Pend12Uhr; if (c == 0) c = 0.579; else c = Math.PI / c;
            sinfak = c;
            double sinx = Math.Sin((x - Pend6Uhr) * sinfak);
            double cosx = Math.Cos((x - Pend6Uhr) * sinfak);
            
            //gPB.DrawLine(p,pointPendTop,pointPendBottom);
            double pos = pictureBox1.Width / 4.0 * wagposist / 10.0;

            paintxold = (int)(pictureBox1.Width / 2.0 - pictureBox1.Width / 4.0*sinx - pos);
            paintyold = (int)(pictureBox1.Height / 2.0 + pictureBox1.Height / 2.3 * cosx);


            pointPendTop = new Point((int)(pictureBox1.Width/2.0-pos), (int)(pictureBox1.Height/2.0));
            pointPendBottom = new Point((int)(paintxold), (int)(paintyold));
            gPB.DrawLine(p ,pointPendTop,pointPendBottom);
            gPB.FillEllipse(pbrush, (float)(paintxold-size*0.5) , (float)(paintyold-size*0.5),size,size);
            
            
        }


        






    }
}
