﻿// since 7.4.7. with irect access to nidaq32.dll
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;// if using dll

namespace WINDF7CSharp
{
    public partial class FormNI : Form
    {
        FormMain meinMain;
        Stopwatch stopwatch1 = new Stopwatch();

        double AD0Display=0, DA0Display = 0;
        
        public FormNI(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            stopwatch1.Start();
            //@NIInit_DA_Brds$qs   @NIAI_Clear$qs
        }
        string nidaqnotfound = "nidaq32.dll not found";
        
        [DllImport("nidaq32.dll", EntryPoint = "Init_DA_Brds")]
        public extern static short Init_DA_Brds(short slot,ref short brdcode);

 
        [DllImport("nidaq32.dll", EntryPoint = "AO_VWrite")]
        public extern static short AO_VWrite(short slot, short chan, double voltage);

        [DllImport("nidaq32.dll", EntryPoint = "AI_Configure")]
        public extern static short AI_Configure(short deviceNumber, short chan, short inputMode, short inputRange, short polarity, short driveAIS);
        // chan=-1 for all channels
        // inputMode=1 referenced to ground
        // inputRange =20 bipolar  --10V
        // polarity 0 bipolar
        // driveAIS 1 Drive AISENSE to ground.
        //Also mit
        // AI_Configure(1,-1,1,20,0,1);
        //Führt zu :alle Kanäle auf  referenced to ground, bipolar +/- 10Volt, Senseleitungen wenn vorhanden auf ground. Jetzt Wert einlesen mit 

        [DllImport("nidaq32.dll", EntryPoint = "AI_VRead")]
        public extern static short AI_VRead(short slot, short chan, short gain,ref double Uin);
        // gain = -1 bedeutet +-10 V, +1 bedeutet +-5V

        long dtend = 0, dt = 0, dtavr = 0, cntT0 = 0, dtavr2 = 0;
        bool initOK = false;
        short ex=1;
        short test = 0; 
 
        private void buttonInit_Click(object sender, EventArgs e)
        {

            if (!initOK)
            {
                try
                {
                    ex = Init_DA_Brds((short)1, ref test);
                    ex = AI_Configure(1, -1, 1, 20, 0, 1);
                }
                catch
                {
                    MessageBox.Show(nidaqnotfound);
                    ex = 1;
                }
            }
            if (ex == 0)
            {
                label1.Text = "OK"+" Board Code: "+test.ToString();
                timer1.Enabled = true;
                numericUpDownDAC_A_ValueChanged(sender, e);
                numericUpDownVoltDAC_B_ValueChanged(sender, e);
                meinMain.selectedADC = "NI trad";
                groupBoxTimeronoff.Enabled = true;
                rBTTOff.Checked = false;
                initOK = true;
                timerAnzeige.Start();
            }
            else label1.Text = "NOK";
        }


        private void buttonselect_Click(object sender, EventArgs e)
        {

            try
            {
                ex = AI_Configure(1, -1, 1, 20, 0, 1);
            }
            catch
            {
                MessageBox.Show(nidaqnotfound);
                ex = 1;
            }

            if (ex == 0)
            {
                label1.Text = "OK" + " Board Code: " + test.ToString();
                timer1.Enabled = true;
                numericUpDownDAC_A_ValueChanged(sender, e);
                numericUpDownVoltDAC_B_ValueChanged(sender, e);
                meinMain.selectedADC = "NI trad";
                groupBoxTimeronoff.Enabled = true;
                rBTTOff.Checked = false;
                initOK = true;
                timerAnzeige.Start();
            }
            else label1.Text = "NOK";

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            long dtstart = stopwatch1.ElapsedTicks;
            int ex = 0;
            double val = 0;
            ex=AI_VRead(1, 0, -1, ref val);
            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - dtstart);  // Time AD
            dtavr = dtavr + dt;

            label2.Text = "Chan 0=  " + val.ToString("f4") + " Volt";
            ex = AI_VRead(1, 1, -1,ref val);
            label3.Text = "Chan 1=  " + val.ToString("f4") + " Volt";

            short outval = (short)numericUpDownDAC_A.Value;
            dtstart = stopwatch1.ElapsedTicks;
            ex = AO_VWrite(1, 0, (double)outval);
            dt = (stopwatch1.ElapsedTicks - dtstart);  // Time DA
            dtavr2 = dtavr2 + dt;
            cntT0++;
            if (this.WindowState == FormWindowState.Minimized) rBTTOff.Checked = true;
            // Switch off if Minimized

        }

        private void numericUpDownDAC_A_ValueChanged(object sender, EventArgs e)
        {
            short outval = (short)numericUpDownDAC_A.Value;
            int ex = AO_VWrite(1, 0, (double)outval);
            if (ex == 0) label1.Text = "OK"; else label1.Text = "NOK";



        }

        private void numericUpDownVoltDAC_B_ValueChanged(object sender, EventArgs e)
        {
            short outval = (short)numericUpDownVoltDAC_B.Value;
            int ex = AO_VWrite(1, 1, (double)outval);
            if (ex == 0) label1.Text = "OK"; else label1.Text = "NOK";

        }

        private void FormNI_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            timer1.Stop();
            dtavr = 0;
            dtavr2 = 0;
            rBTTOff.Checked = true;
        }
  
        public void InputNI(short chan, ref double val)
        {
            
            int ex = AI_VRead(1, chan, -1,ref val);
            AD0Display = val;
        }

        public void OutputNI(short chan, double val)
        {
            if (val > 9.999) val = 9.999;
            if (val < -9.999) val = -9.999;
            int ex = AO_VWrite(1, chan, (double)val);
            DA0Display = val;

        }

        private void timerAnzeige_Tick(object sender, EventArgs e)
        {
            if (cntT0 > 0)
            {
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                toolStripStatusLabel2.Text = "DtAD= " + dtavr1.ToString("f2");
                double dtav2 = dtavr2 / (double)Stopwatch.Frequency * 1000;
                toolStripStatusLabel2.Text += " ms  DtDA= " + dtav2.ToString("f2") + " ms";
                dtavr2 = 0; dtavr = 0; cntT0 = 0;
            }
            toolStripStatusLabel1.Text = "AD0=  " + AD0Display.ToString("f2") + "  DA0=  " + DA0Display.ToString("F2");

        }

        private void rBTTOff_CheckedChanged(object sender, EventArgs e)
        {
            if (rBTTOff.Checked) timer1.Enabled = false;
            else timer1.Enabled = true;

        }

    }
}
