﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MPS;
using System.Diagnostics; // Aus MultimediaTimer.dll


namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormSampleHold : Form
    {
        public FormSampleHold(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            MMTimer1 = new TMultimediaTimer(null); // --> null means no callback invoking --> less overhead 
            //       --> less CPU load
            MMTimer1.Interval = 10;                 // --> 10ms interval
            MMTimer1.OnTimer = EventVomMMTimer;
            stopwatch.Start();

        }
        FormMain meinMain;

        Stopwatch stopwatch = new Stopwatch();
        double stoptm, timeAvr = 0;

        TMultimediaTimer MMTimer1;
        double starttmMM, stoptmMM, timeAvrMM = 0, TimeMin = 0;
        int cntMM = 1;
        int indexstore = 0;
        double [] samples = new double[1000];

        private void buttonDFon_Click(object sender, EventArgs e)
        {
            labelDurationTime.Visible = true;
            labelDuration.Visible = true;
            labelPeriod.Visible = true;
            label1.Visible = true;
            labelMinDurNb.Visible = true;
            labelMinDur.Visible = true;

            MMTimer1.Interval = (uint)(numericUpDown1.Value);  //t0run in msec
            MMTimer1.Enable();
            t0rtc = (double)numericUpDown1.Value * 0.001;
            timerDisplay.Enabled = true;

        }

        private void buttonDFoff_Click(object sender, EventArgs e)
        {

            labelDurationTime.Visible = false;
            labelDuration.Visible = false;
            labelPeriod.Visible = false;
            label1.Visible = false;
            labelMinDurNb.Visible = false;
            labelMinDur.Visible = false;

            MMTimer1.Disable();
            timerDisplay.Enabled = false;

        }

        private void timerDisplay_Tick(object sender, EventArgs e)
        {
            if (cntMM > 0)
            {
                labelPeriod.Text = (timeAvrMM / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelDurationTime.Text = (timeAvr / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelMinDurNb.Text = (TimeMin / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                timeAvrMM = 0;
                timeAvr = 0;
                cntMM = 0;
                TimeMin = 1e10;
                labelADCout.Text = help.ToString("f2");
                if ((indexstore > 2)&& cBWithChart.Checked)
                {
                    MMTimer1.Disable();
                    chart2D1.clearAll();
                    for (int i = 0; i < indexstore; i++)
                    {
                        chart2D1.setPoint(0, i * t0rtc, samples[i]);
                    }
                    //chart2D1.autoScaling();
                    chart2D1.XMax = 1;
                    chart2D1.XMin = 0;
                    chart2D1.YMax = 10;
                    chart2D1.YMin = -10;
                    chart2D1.YGap = 1;
                    chart2D1.XGap = 0.1;
                    chart2D1.startDrawing();
                    indexstore = 0;
                    MMTimer1.Enable();
                }
            }

        }
        double help = 0;
        
        void EventVomMMTimer(TMultimediaTimer sender)
        {
            double duration;
            starttmMM = stoptmMM;
            stoptmMM = stopwatch.ElapsedTicks;
            timeAvrMM += (stoptmMM - starttmMM);  // Period
            cntMM++;
            // Now filter calculation
            meinMain.ADCinput((short)nudChanAD.Value, ref help);  // Filter Input ADC
            // only "Sample and Hold"
            samples[indexstore] = help;
            meinMain.DACoutput((short)nudChanDA.Value, help);  // Signal out to DAC

            stoptm = stopwatch.ElapsedTicks;
            duration = stoptm - stoptmMM;// Duration
            timeAvr += duration;
            if (duration < TimeMin) TimeMin = duration; // look for minimal duration time
            if (cBWithChart.Checked) indexstore++;
            if (indexstore > 999) indexstore = 999;
        }

        double t0rtc = 0.010;
        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            MMTimer1.Disable();
            MMTimer1.Interval = (uint)(numericUpDown1.Value);  //t0run in msec
            MMTimer1.Enable();
            t0rtc=(double)numericUpDown1.Value*0.001;

        }

        private void FormSampleHold_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void cBWithChart_CheckedChanged(object sender, EventArgs e)
        {
            chart2D1.Visible = cBWithChart.Checked;
        }

    }
}
