﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;
using System.Diagnostics;
using WINDF7CSharp;


namespace DT9062
{
    public partial class FormDT9062 : Form
    {
        FormMain meinMain;
        
        public FormDT9062(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            stw.Start();
            // ImageList stores images as large BMPs, in resources storage as jpg
            // The imagelist with this 10 images as BMP has size of 1 MB!!
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment0);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment1);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment2);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment3);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment4);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment5);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment6);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment7);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment8);
            imageList1.Images.Add(global::WINDF7CSharp.Properties.Resources._7segment9);

        }

        Stopwatch stw = new Stopwatch();

        private void buttonOpen_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
            
            serialPort1.Open();

            if(serialPort1.IsOpen)
            {
                buttonStratRec.Enabled = true;
                label2.Text=serialPort1.PortName+"  is now open";
                pictureBox1.Image = imageList1.Images[0];
                pictureBox2.Image = imageList1.Images[0];
                pictureBox3.Image = imageList1.Images[0];
                pictureBox4.Image = imageList1.Images[0];
            }
            else
                label2.Text = "No Port is open";
        }

        private void buttonSend_Click(object sender, EventArgs e)
        {
        }

        private void comboBox1_SelectedValueChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.PortName = cbPort.Text;


        }

        private void Check_Click(object sender, EventArgs e)
        {
            cbPort.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                cbPort.Items.Add(s);
            }

        }

        private void buttonStratRec_Click(object sender, EventArgs e)
        {
            serialPort1.DtrEnable = true;
            if (serialPort1.IsOpen)
            {
                if (timer1.Enabled)
                {
                    timer1.Enabled = false;
                    timerLogger.Enabled = false;
                    buttonStratRec.Text = "Start again";
                }
                else
                {
                    timer1.Enabled = true;
                    timerLogger.Enabled = true;
                    buttonStratRec.Text = "Stop";
                }
            }
                    
        
        }
        double cnt = 0;
        double time;           
        string inp = "";

        int bytecnt;



        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = DateTime.Now.ToString();// only to see thats timer is running
            bytecnt=0;// To be sure that number comes from a complete cycle
            if (serialPort1.BytesToRead > 0)
            {
                double start = stw.ElapsedTicks;
                
                while ((serialPort1.BytesToRead > 0)&&(bytecnt<9))
                {

                    int c = serialPort1.ReadByte();
                    int low = 0;
                    //int low9 = 0;
                    //int low91 = 0;
                    //int low92 = 0;
                    //int low93 = 0;
                    //int lo=0;                   
                    int high = c & 0xF0;
                    high = high >> 4;

                    panelp3.BackColor = Color.Tomato;

                    if (high == 1)
                    {
                        bytecnt = 1;
                        low = c & 0x0F;

                        int low1L5 = (low & 0x2);
                        if (low1L5 == 2) label5.Text = "Auto";
                        else label5.Text = "";

                        int low6L6 = (low & 0x1);
                        if (low6L6 == 1) label6.Text = "RS232";
                        else label6.Text = "";
                    }

                    if (high == 2)
                    {
                        bytecnt++;
                        low = c & 0x0F;

                        int lowMinus = (low & 0x8);
                        if (lowMinus == 8) panelMinus.BackColor = Color.Tomato;
                        else panelMinus.BackColor = Color.White;

                        int low41 = (low & 0x4);
                        if (low41 == 4) panel41.BackColor = Color.Tomato;
                        else panel41.BackColor = Color.White;

                        int low11 = (low & 0x2);
                        if (low11 == 2) panel11.BackColor = Color.Tomato;
                        else panel11.BackColor = Color.White;

                        int low61 = (low & 0x1);
                        if (low61 == 1) panel61.BackColor = Color.Tomato;
                        else panel61.BackColor = Color.White;

                        int low91 = (low & 0x8);  // minus
                        if (low91 == 8) pictureBoxminus.Visible = true;
                        else pictureBoxminus.Visible = false;
                    }

                    if (high == 3)
                    {
                        low = c & 0x0F;
                        bytecnt++;
                        int low2a = (low & 0x8);
                        if (low2a == 8) panel2a.BackColor = Color.Tomato;
                        else panel2a.BackColor = Color.White;

                        int low31 = (low & 0x4);
                        if (low31 == 4) panel31.BackColor = Color.Tomato;
                        else panel31.BackColor = Color.White;

                        int low71 = (low & 0x2);
                        if (low71 == 2) panel71.BackColor = Color.Tomato;
                        else panel71.BackColor = Color.White;

                        int low51 = (low & 0x1);
                        if (low51 == 1) panel51.BackColor = Color.Tomato;
                        else panel51.BackColor = Color.White;

                    }

                    if (panelMinus.BackColor == Color.Tomato)
                    {
                        Minus.Text = "-";
                    }
                    else Minus.Text = "";


                    if (high == 4)
                    {
                        bytecnt++;

                        low = c & 0x0F;


                        int low42 = (low & 0x4);
                        if (low42 == 4) panel42.BackColor = Color.Tomato;
                        else panel42.BackColor = Color.White;

                        int low12 = (low & 0x2);
                        if (low12 == 2) panel12.BackColor = Color.Tomato;
                        else panel12.BackColor = Color.White;

                        int low62 = (low & 0x1);
                        if (low62 == 1) panel62.BackColor = Color.Tomato;
                        else panel62.BackColor = Color.White;

                        int low92 = (low & 0x8);  // DP
                        if (low92 == 8) pictureBoxDP1.Visible = true;
                        else pictureBoxDP1.Visible = false;

                    }

                    if (high == 5)
                    {
                        low = c & 0x0F;
                        bytecnt++;
                        int low2b = (low & 0x8);
                        if (low2b == 8) panel2b.BackColor = Color.Tomato;
                        else panel2b.BackColor = Color.White;

                        int low32 = (low & 0x4);
                        if (low32 == 4) panel32.BackColor = Color.Tomato;
                        else panel32.BackColor = Color.White;

                        int low72 = (low & 0x2);
                        if (low72 == 2) panel72.BackColor = Color.Tomato;
                        else panel72.BackColor = Color.White;

                        int low52 = (low & 0x1);
                        if (low52 == 1) panel52.BackColor = Color.Tomato;
                        else panel52.BackColor = Color.White;

                    }


                    if (high == 6)
                    {
                        bytecnt++;
                        low = c & 0x0F;

                        int low43 = (low & 0x4);
                        if (low43 == 4) panel43.BackColor = Color.Tomato;
                        else panel43.BackColor = Color.White;

                        int low13 = (low & 0x2);
                        if (low13 == 2) panel13.BackColor = Color.Tomato;
                        else panel13.BackColor = Color.White;

                        int low63 = (low & 0x1);
                        if (low63 == 1) panel63.BackColor = Color.Tomato;
                        else panel63.BackColor = Color.White;

                        int low93 = (low & 0x8);  // DP
                        if (low93 == 8) pictureBoxDP2.Visible = true;
                        else pictureBoxDP2.Visible = false;
                    }

                    if (high == 7)
                    {
                        low = c & 0x0F;
                        bytecnt++;
                        int low2c = (low & 0x8);
                        if (low2c == 8) panel2c.BackColor = Color.Tomato;
                        else panel2c.BackColor = Color.White;

                        int low33 = (low & 0x4);
                        if (low33 == 4) panel33.BackColor = Color.Tomato;
                        else panel33.BackColor = Color.White;

                        int low73 = (low & 0x2);
                        if (low73 == 2) panel73.BackColor = Color.Tomato;
                        else panel73.BackColor = Color.White;

                        int low53 = (low & 0x1);
                        if (low53 == 1) panel53.BackColor = Color.Tomato;
                        else panel53.BackColor = Color.White;

                    }



                    if (high == 8)
                    {

                        low = c & 0x0F;
                        bytecnt++;

                        int low4 = (low & 0x4);
                        if (low4 == 4) panel4.BackColor = Color.Tomato;
                        else panel4.BackColor = Color.White;

                        int low1 = (low & 0x2);
                        if (low1 == 2) panel1.BackColor = Color.Tomato;
                        else panel1.BackColor = Color.White;

                        int low6 = (low & 0x1);
                        if (low6 == 1) panel6.BackColor = Color.Tomato;
                        else panel6.BackColor = Color.White;

                        int low93 = (low & 0x8);  // DP
                        if (low93 == 8) pictureBoxDP3.Visible = true;
                        else pictureBoxDP3.Visible = false;
                    }

                    if (high == 9)
                    {
                        low = c & 0x0F;
                        bytecnt++;
                        int low2 = (low & 0x8);
                        if (low2 == 8) panel2.BackColor = Color.Tomato;
                        else panel2.BackColor = Color.White;

                        int low3 = (low & 0x4);
                        if (low3 == 4) panel3.BackColor = Color.Tomato;
                        else panel3.BackColor = Color.White;

                        int low7 = (low & 0x2);
                        if (low7 == 2) panel7.BackColor = Color.Tomato;
                        else panel7.BackColor = Color.White;

                        int low5 = (low & 0x1);
                        if (low5 == 1) panel5.BackColor = Color.Tomato;
                        else panel5.BackColor = Color.White;
                        
                    }

                    if (bytecnt == 9)
                    {
                        bytecnt = 0;
                        if (panel12.BackColor == Color.Tomato)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.Tomato)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.White)
                                                {
                                                    int zahl = 0;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.White)
                        {
                            if (panel2b.BackColor == Color.White)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.White)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.White)
                                            {
                                                if (panel72.BackColor == Color.White)
                                                {
                                                    int zahl = 1;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.White)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.White)
                                {
                                    if (panel42.BackColor == Color.Tomato)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 2;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.White)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.White)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 3;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.Tomato)
                        {
                            if (panel2b.BackColor == Color.White)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.White)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.White)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 4;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.Tomato)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.White)
                                    {
                                        if (panel52.BackColor == Color.White)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 5;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.Tomato)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.Tomato)
                                    {
                                        if (panel52.BackColor == Color.White)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 6;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.White)
                        {
                            if (panel2b.BackColor == Color.White)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.White)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.White)
                                                {
                                                    int zahl = 7;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.Tomato)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.Tomato)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 8;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel12.BackColor == Color.Tomato)
                        {
                            if (panel2b.BackColor == Color.Tomato)
                            {
                                if (panel32.BackColor == Color.Tomato)
                                {
                                    if (panel42.BackColor == Color.White)
                                    {
                                        if (panel52.BackColor == Color.Tomato)
                                        {
                                            if (panel62.BackColor == Color.Tomato)
                                            {
                                                if (panel72.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 9;
                                                    ziffer2.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        if (panel11.BackColor == Color.Tomato)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.Tomato)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.White)
                                                {
                                                    int zahl = 0;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.White)
                        {
                            if (panel2a.BackColor == Color.White)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.White)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.White)
                                            {
                                                if (panel71.BackColor == Color.White)
                                                {
                                                    int zahl = 1;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.White)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.White)
                                {
                                    if (panel41.BackColor == Color.Tomato)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 2;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.White)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.White)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 3;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.Tomato)
                        {
                            if (panel2a.BackColor == Color.White)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.White)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.White)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 4;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.Tomato)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.White)
                                    {
                                        if (panel51.BackColor == Color.White)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 5;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.Tomato)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.Tomato)
                                    {
                                        if (panel51.BackColor == Color.White)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 6;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.White)
                        {
                            if (panel2a.BackColor == Color.White)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.White)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.White)
                                                {
                                                    int zahl = 7;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.Tomato)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.Tomato)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 8;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel11.BackColor == Color.Tomato)
                        {
                            if (panel2a.BackColor == Color.Tomato)
                            {
                                if (panel31.BackColor == Color.Tomato)
                                {
                                    if (panel41.BackColor == Color.White)
                                    {
                                        if (panel51.BackColor == Color.Tomato)
                                        {
                                            if (panel61.BackColor == Color.Tomato)
                                            {
                                                if (panel71.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 9;
                                                    ziffer1.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.Tomato)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.Tomato)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.White)
                                                {
                                                    int zahl = 0;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.White)
                        {
                            if (panel2.BackColor == Color.White)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.White)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.White)
                                            {
                                                if (panel7.BackColor == Color.White)
                                                {
                                                    int zahl = 1;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.White)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.White)
                                {
                                    if (panel4.BackColor == Color.Tomato)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 2;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.White)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.White)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 3;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.Tomato)
                        {
                            if (panel2.BackColor == Color.White)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.White)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.White)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 4;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.Tomato)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.White)
                                    {
                                        if (panel5.BackColor == Color.White)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 5;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.Tomato)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.Tomato)
                                    {
                                        if (panel5.BackColor == Color.White)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 6;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.White)
                        {
                            if (panel2.BackColor == Color.White)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.White)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.White)
                                                {
                                                    int zahl = 7;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.Tomato)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.Tomato)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 8;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel1.BackColor == Color.Tomato)
                        {
                            if (panel2.BackColor == Color.Tomato)
                            {
                                if (panel3.BackColor == Color.Tomato)
                                {
                                    if (panel4.BackColor == Color.White)
                                    {
                                        if (panel5.BackColor == Color.Tomato)
                                        {
                                            if (panel6.BackColor == Color.Tomato)
                                            {
                                                if (panel7.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 9;
                                                    ziffer4.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.Tomato)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.Tomato)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.White)
                                                {
                                                    int zahl = 0;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.White)
                        {
                            if (panel2c.BackColor == Color.White)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.White)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.White)
                                            {
                                                if (panel73.BackColor == Color.White)
                                                {
                                                    int zahl = 1;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.White)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.White)
                                {
                                    if (panel43.BackColor == Color.Tomato)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 2;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.White)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.White)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 3;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.Tomato)
                        {
                            if (panel2c.BackColor == Color.White)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.White)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.White)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 4;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.Tomato)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.White)
                                    {
                                        if (panel53.BackColor == Color.White)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 5;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.Tomato)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.Tomato)
                                    {
                                        if (panel53.BackColor == Color.White)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 6;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.White)
                        {
                            if (panel2c.BackColor == Color.White)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.White)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.White)
                                                {
                                                    int zahl = 7;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.Tomato)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.Tomato)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 8;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (panel13.BackColor == Color.Tomato)
                        {
                            if (panel2c.BackColor == Color.Tomato)
                            {
                                if (panel33.BackColor == Color.Tomato)
                                {
                                    if (panel43.BackColor == Color.White)
                                    {
                                        if (panel53.BackColor == Color.Tomato)
                                        {
                                            if (panel63.BackColor == Color.Tomato)
                                            {
                                                if (panel73.BackColor == Color.Tomato)
                                                {
                                                    int zahl = 9;
                                                    ziffer3.Text = zahl.ToString();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }  
                }

                cnt++;



                pictureBox1.Image = imageList1.Images[Convert.ToInt32(ziffer1.Text)];
                pictureBox2.Image = imageList1.Images[Convert.ToInt32(ziffer2.Text)];
                pictureBox3.Image = imageList1.Images[Convert.ToInt32(ziffer3.Text)];
                pictureBox4.Image = imageList1.Images[Convert.ToInt32(ziffer4.Text)];
                double stop = stw.ElapsedTicks;
                toolStripStatusLabel2.Text = ((stop - start) / Stopwatch.Frequency * 1000.0).ToString("f2") + "  ms";
            }
        }


        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.BaudRate=int.Parse(comboBox1.Text);

        }


        private void buttonClose_Click(object sender, EventArgs e)
        {
            serialPort1.Close();
            label2.Text = " No COM open";
            timer1.Enabled = false;
            buttonStratRec.Enabled = false;
        }

 
        private void buttonClearTB1_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            cnt = 0;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void buttonDraw_Click(object sender, EventArgs e)
        {
            if (textBox1.Lines.Length > 3)
            {
                meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBox1, ref meinMain.minmaxMain, meinMain.LOMain);
                meinMain.enableCurveButtons();
            }

        }

        private void timerLogger_Tick(object sender, EventArgs e)
        {
            time = cnt;
            inp = time.ToString()+" "+Minus.Text + ziffer1.Text + ziffer2.Text + ziffer3.Text + "." + ziffer4.Text + "\x0d\x0a"; //"\r\n";
            textBox1.AppendText(inp);
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timerLogger.Interval = ((int)numericUpDown1.Value) * 1000;
        }

 
     
    }
}
