﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using MPS;                           //using multimediatimer
using WINDF7CSharp;
using System.Runtime.InteropServices;
using AConInfo;


// Init Program for student use 
// stud_algorithm() is cleaned


namespace StudControl
{
    public partial class FormStudControl : Form
    {
        const int maxpoints = 3001;
        const int maxnp2 = 14;  //max degree of DB / Orientation is 10

        TMultimediaTimer MMTimer1;
        double xoff = 0, uoff = 0, amp = 0, xroff = 0; //initialization of voltage
        public double w = 0;                         //public variable w ,the expected output, to be called by other objects
        public double val;                           //public variable val, the voltage input from motor, to be called by other objects

        FormMain meinMain;
        Boolean onRecord = false;  //indication of button RunRSR being pressed or not
        public bool RunOn = false; //public indication of whether motor being running

        short i = 0, nb = 0;       //curve point indication i, curve points numbers nb
        int indexRec = 0;            //pulse number

        public double q0p, q0n, q1n, q0d, p1n, q1d, q0i, q1i, q2i, p1i, p1f, p2f, q0f, q1f, q2f, q0fPD, q1fPD, q2fPD; //{PID-params,}
        //p=P //n=PI  //i=PID  // d=PD // f= PIDT1 free
        double q0ac, q0ic, q1ic;//cascaded
        double TwoPointUp, TwoPointDown;
        int mgradCon;
        double limitation = 0;
        double z1 = 0, z2 = 0;
        double t0start = 0, t0end = 0; double dtstart = 0, dtend = 0; double dtmax = 0; double dt = 0; //variables related to standard timer  for displaying dT to and dTMAX
        int cntT0 = 0;
        double t0avr = 0, dtavr = 0;
        int Ncon = 0;  //Ncon stands for selected controller for button RSR
        int InitialType = 3;//InitialType stands for initial controller for button RUN
        string ConType = "P";
        int pulse = 0;
        bool recOn = false; bool stepOn = true;

        bool procSR = false; double procInputBeforePSR = 0, firstVal = 0;
        const int filtnb = 10;  // Digital Filter to get the Process input average before process step response
        private double[] xrBeforeStep = new double[filtnb];

        string[] pars = new string[4];
        int thisdrawnum = 1;
        FromAControlInfo acinfo = new FromAControlInfo();
        Stopwatch stopwatch1 = new Stopwatch();

        double yout = 0; double yold = 0, yold2 = 0; double xdold1 = 0; double xdold2 = 0;
        double youtDisplay = 0, youtdisplayfiltered = 0;
        int idisplay = 0;
        double yoldI, xdn1casI, youtI, x1casI;  // Cascaded controller before RSR
        double q0Init, q1Init, xd1Init = 0;
        double ncas, xdn1cas, xdncas, wncas, x1cas;  // cascaded controller

        public double t0rtc;

        string maxpts = "Max Points= ";
        double[,] ayval = new double[maxpoints, 2]; //storage for double value of points on curves
        double[,] awval = new double[maxpoints, 2];
        double[,] axrval = new double[maxpoints, 2];
        string OneCurvenecessary = "One Curve is necessary";
        int lastNbOfPoints = 0;

        public double[] xd = new double[maxnp2];    // control error
        public double[] xa = new double[maxnp2];    // process output val
        public double[] xr = new double[maxnp2];    // controller output

        string FilterName = "RTC- Data";
        string points = "Points";
        LoadOpt LOrtc = new LoadOpt();
        string CRLF = "\r\n";

        double DZcompensation = 0, NoiseAtZ1 = 0;
        Random NoiseZ1 = new Random();


        CHMinMax minmax;

        public FormStudControl(FormMain m)
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;
            meinMain = m;
            MMTimer1 = new TMultimediaTimer(null);

            MMTimer1.OnTimer = EventVomMMTimer;
            dataGridViewControllerPar.Rows.Add("0", "0");       //add three new rows in datagridviewControllerPar,waiting for incoming control parameters
            dataGridViewControllerPar.Rows.Add("0", "0");
            dataGridViewControllerPar.Rows.Add("0", "0");
            minmax = new CHMinMax();
            minmax.init();

            //initgraph(ref axChartfx1);
            stopwatch1.Start();

            // Init Values Breathing System
            q0p = 4.23; q0d = 31.608; q1d = -23.706;
            q0n = 1.94487; q1n = -1.9148; q0i = 15.528; q1i = -26.704; q2i = 11.294; p1n = 1; p1i = 1;
            // Cascades controller for Breathing system
            q0ac = 30.0; q0ic = 0.201; q1ic = -0.17;
            TwoPointDown = -10.0;
            TwoPointUp = 10.0;
            t0rtc = 0.01;
            labelMaxPoints.Text = maxpts + (maxpoints - 1).ToString();
            numPoints.Maximum = maxpoints - 1;
            //toolStripButton12_Click(null, null);
            LOrtc.init();
            tBiniQ0_Leave(null, null);
            chart2D1.CurveColor0 = Color.Blue;
            chart2D1.AllClearButton = false;
            chart2D1.LastClearButton = false;
        }

        private void FormStudControl_Load(object sender, EventArgs e)
        {
            rbPcon_CheckedChanged(sender, e);
            pq2DataGrid();
            Tabs.SelectedIndex = 4;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[4] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[4] ab.
            Tabs.SelectedIndex = 3;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[3] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[3] ab.
            Tabs.SelectedIndex = 2;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[5] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[5] ab.
            Tabs.SelectedIndex = 0;
        }

        public void deutsch()
        {
            OneCurvenecessary = "Mindestens eine Kurve ist nötig";
            maxpts = "Max. Punkte";
            FilterName = "Echtzeitkurve";
            points = "Punkte";
            this.Text = "Echtzeitregler";
            buttonRSR.Text = "Start FSA";
            toolTip1.SetToolTip(buttonRSR, "Starte Führungs- oder Störsprungantwort");
            butProcStepResp.Text = "Start SSA";
            toolTip1.SetToolTip(butProcStepResp, "Starte Streckensprungantwort");
            rsbHelp.ToolTipText = "Öffne Signalflussplan";
            tsbWriteReport.ToolTipText = "Speichere beliebige Kurve als .sim - Datei";
            tsbGreenOK.ToolTipText = "Schließe Fenster und aktiviere Identifikation";
            tsbClose.ToolTipText = "Schließe Fenster und ignoriere Ergebnisse";
            tsbClearX.ToolTipText = "Text löschen";
            tsbClearW.ToolTipText = "Text löschen";
            tsbClearXr.ToolTipText = "Text löschen";
            tsbsaveW.ToolTipText = "Speicher W-Werte als .Sim- Datei";
            tsbSaveX_.ToolTipText = "Speicher X-Werte als .Sim- Datei";
            tsbSaveXr.ToolTipText = "Speicher Xr-Werte als .Sim- Datei";
            tsbReportX_.ToolTipText = "Erzeuge Report der letzten X- Werte";
            tsbReportW.ToolTipText = "Erzeuge Report der letzten W- Werte";
            tsbReportXr.ToolTipText = "Erzeuge Report der letzten Xr- Werte";
            toolTip1.SetToolTip(buttonPQenter, "Übernehme Änderungen der p-q-Werte");
            toolTip1.SetToolTip(cBUnitSR, "Wenn geklickt, konvertiere in Einheitssprungantwort");
            toolTip1.SetToolTip(tbComp, "Kompensation der toten Zone");
            groupBox12.Text = "Echtzeitwerte";
            cbRealtimeDevice.Text = "Echtzeitkurve";
            groupBox2.Text = "Reglertyp";
            rbCascadedcon.Text = "Kaskade";
            toolTip1.SetToolTip(butFreeContr, "Freier PID");
            butFreeContr.Text = "Freier PID";
            rbFreecon.Text = "Freier PID";
            groupBox4.Text = "Ablauf Funktion";
            rbStepAutostop.Text = "Sprung, autostop";
            rbRectContinous.Text = "kont. Rechteck";
            rbInputAtADC.Text = "w vom AD";
            rbImpulsAutostop.Text = "Impuls, autostop";
            groupBox7.Text = "Anfangswerte nach RUN";
            groupBox5.Text = "Signal AMP an";
            groupBox6.Text = "Xr nach Autostop";
            cbNoiseZ1.Text = "Rauschen an Z1";
            toolTip1.SetToolTip(cbNoiseZ1, "Kann zur LS- Offline-Identifikation genutzt werden");
            rbInitialUoffByP.Text = "Uoff geregelt mit PI";
            rbInitialUoffByPI.Text = "Uoff geregelt mit Kask. Reg.";
            rbInitialXByCon.Text = "Uoff geregelt mit gewähltem Reg";
            groupBox10.Text = "Regler Parameter";
            groupBoxLimit.Text = "Begrenzung Xr";
            cbLimitation.Text = "Aktiviert +-";
            label29.Text = "Totzonen-Komp.";
            groupBox8.Text = "Streckenparameter";
            label21.Text = "Signal X an Kanal";
            toolTip1.SetToolTip(butFreeContr, "Freier PID");
            toolTip1.SetToolTip(buttonStop, "Stoppt Echtzeitmodus");
            toolTip1.SetToolTip(buttonRUN, "Startet Echtzeitmodus");
            toolTip1.SetToolTip(butProcStepResp, "Messe Streckensprungantwort");
            butProcStepResp.Text = "Start PSA";

            labelMaxPoints.Text = maxpts + maxpoints.ToString();
            tabPage1.Text = "Kurven";
            tabPagePar.Text = "Parameter";
            tabPage5x.Text = "Letzte X- werte";
            tabPage4LastXr.Text = "Letzte Xr- Werte";
            tabPage7LastW.Text = "Letzte W- Werte";
            tabPage6ConPar.Text = "Alle p-q-Reglerparameter";
            label7.Text = "p-q- Liste aller Regler";
            toolTip1.SetToolTip(butLoadContr, "Lade kompletten Set aller Regler");
            toolTip1.SetToolTip(butSaveContr, "Speichere kompletten Set aller Regler");
            toolTip1.SetToolTip(butAktivatepqChange, "Aktiviert Änderungen anden p-q- Werten");
            butAktivatepqChange.Text = "Aktiviere Änderungen";
            TSBClearLast.ToolTipText = "Lösche letzte Kurve";
            tsbClearAll.ToolTipText = "Lösche alle Kurven";
            toolTip1.SetToolTip(butdrawAgain, "Zeichne nochmal");
            acinfo.pictureBoxGer.Visible = true;
            chart2D1.Germanlanguage = true;
        }

 
        // your student parameters should start with _
        // double _newPar;

        public void stud_algorithm()
        {
            double xd0 = 0;
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);
            meinMain.DACoutput((short)nudChanDA.Value, yout);
            youtDisplay = yout;
            xd0 = w - val;   // control difference

            switch (Ncon)
            {
                case 0: yout = 0; break;//P controller
                case 1: yout = 0; break;//PDT1 controller
                case 2: yout = 0; break;//PI controller
                case 3: yout = 0; break; //PIDT1 controller 
                case 6: yout = 0; break; // Dead beat controller
                case 5: yout = 0; break; // Pidt1 with Anti Wind Up
                default: yout = 10 * xd0;
                    break;
            }

            yout = yout + z1;

            if (yout > 0) yout = yout + DZcompensation; else yout = yout - DZcompensation; //Dead Zone compensation

            if (cbLimitation.Checked)
            {
                if (yout > limitation) yout = limitation;
                if (yout < -limitation) yout = -limitation;
            }
        }



        void EventVomMMTimer(TMultimediaTimer sender)
        {
            double xd0, help;
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            t0avr = t0avr + (t0start - t0end);  //calculating t0
            dtstart = stopwatch1.ElapsedTicks;
            if (onRecord == true)
            {   // after pressing RSR- or PSR button

                if (i < (int)numPoints.Value)
                {
                    //calculation loop starts
                    idisplay = i;
                    minmax.progress = i;
                    ayval[i, 0] = i * t0rtc;
                    awval[i, 0] = i * t0rtc;
                    axrval[i, 0] = i * t0rtc;
                    if ((rbImpulsAutostop.Checked) && (i > pulse)) w = uoff;
                    if (cbNoiseZ1.Checked)
                    {
                        help = NoiseZ1.Next(1000);  //Random number 0-999
                        w = uoff + NoiseAtZ1 * help / 1000.0;
                    }
                    if (procSR)  // process step response autostop
                    {
                        w = amp;   // Only Amplitude is given to process input without offset
                        z1 = 0;
                        z2 = 0;
                        meinMain.DACoutput((short)nudChanDA.Value, youtdisplayfiltered + w);   // Starting Value + w
                        youtDisplay = youtdisplayfiltered + w;
                        meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible
                        if (i == 0)
                        { 
                            firstVal = val; axrval[0, 1] = 0;
                         }

                        if (!cBUnitSR.Checked)
                        {
                            ayval[i, 1] = val;
                            axrval[i, 1] = w + youtdisplayfiltered;
                        }
                        else
                        {
                            ayval[i, 1] = (val - firstVal) / w; // remove offset and Unit step response
                            axrval[i, 1] = w;
                        }
                        // in w is the process input

                    }
                    else
                    {   //reference step respose autostop
                        if (i == 0)
                        {
                            if (rbSignalAtW.Checked)
                            {
                                w = uoff + amp;
                                z1 = 0;
                                z2 = 0;
                            }
                            if (rbSignalAtZ1.Checked)
                            {
                                w = uoff;
                                z1 = amp;
                                z2 = 0;
                            }
                            if (rbSignalAtZ2.Checked)
                            {
                                w = uoff;
                                z2 = amp;
                                z1 = 0;
                            }
                        }
                        if (rBStud.Checked)
                        {
                            stud_algorithm();
                        }
                        else
                        {
                            ProfAlgorithm();
                        }
                        ayval[i, 1] = val;
                        awval[i, 1] = w;// in w is the process input
                        if (rbReal.Checked)
                        {
                            axrval[i + 1, 1] = yout;
                            if (i == 0) axrval[0, 1] = 0;
                        }
                        else axrval[i, 1] = yout;// ideal
                    }
                    i++;
                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(w, val, cbDisplayW.Checked,t0rtc);

                    //toolStripStatusLabel1.Text = "i= " + i.ToString();
                    //Application.DoEvents();
                    //calculation loop ends
                }
                else
                {   // now autostop 
                    //after control loop,stops timers, drawing graphic
                    onRecord = false;
                    MMTimer1.Disable();
                    System.Threading.Thread.Sleep(100);//waiting for last dT calculation
                    timer2.Enabled = false;
                    lastNbOfPoints = i;
                    Application.DoEvents();
                    if (rbXrAfterStepZero.Checked)
                        meinMain.DACoutput((short)nudChanDA.Value, 0);
                    //tbLastValuesX.Clear();
                    //tBLastValuesXr.Clear();
                    //tBLastValuesW.Clear();
                    tsbReportX__Click_1(sender, null);
                    tsbReportXr_Click(sender, null); 
                    tsbReportW_Click(sender, null);
 
                   nb = i;
                    i = 0;

                    buttonStop.Enabled = false;
                    buttonRSR.Enabled = false;
                    butProcStepResp.Enabled = false;
                    tStripProgressBar1.Visible = false;
                    RunOn = false;
                    EventArgs weg = new EventArgs();

                    Tabs.SelectedTab = tabPage1;
                    timerDraw.Enabled = true;
                    //tabPage1.Show();
                }
            }
            else
            {
                // continuous initial phase
                // before control loop ,in button RUN 
                if (stepOn)
                {

                    switch (InitialType)
                    {
                        case 0: youtI = 0; meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            meinMain.ADCinput((short)nudSignalIn.Value, ref val); // to see process output
                            break;
                        case 1: youtI = xroff; meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            meinMain.ADCinput((short)nudSignalIn.Value, ref val);// to see process output
                            break;
                        case 2:
                            {
                                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                                xd0 = w - val;
                                youtI = yoldI + q0Init * xd0 + q1Init * xd1Init;
                                yoldI = youtI; xd1Init = xd0;
                                if (cbLimitation.Checked)
                                {
                                    if (youtI > limitation) youtI = limitation;
                                    if (youtI < -limitation) youtI = -limitation;
                                }
                                meinMain.DACoutput((short)nudChanDA.Value, youtI);

                            } break;
                        case 3:
                            {   // Cascaded controller  q0ak=30;q0ik=0.201;q1ik=-0.17; /
                                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                                xd0 = w - val;
                                ncas = (val - x1casI) / t0rtc;  // speed by differentiating 
                                wncas = 30.0 * xd0;    // outer P-controller  
                                xdncas = wncas - ncas;
                                youtI = yoldI + 0.201 * xdncas - 0.17 * xdn1casI;   // PI-controller inner loop 
                                x1casI = val; xdn1casI = xdncas;
                                if (Math.Abs(youtI) > limitation) youtI = youtI + (0.17 - 0.201) * xdncas;//AWU
                                yoldI = youtI;
                                if (cbLimitation.Checked)
                                {
                                    if (youtI > limitation) youtI = limitation;
                                    if (youtI < -limitation) youtI = -limitation;
                                }
                                meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            } break;
                        case 4: ProfAlgorithm(); youtI = yout; break;
                        default:
                            break;
                    }
                    youtDisplay = youtI;
                    youtdisplayfiltered = procInputBeforePSR;
                    xrBeforeStep[filtnb - 1] = youtI;
                    procInputBeforePSR = youtI;
                    for (int i = 0; i < (filtnb - 1); i++)
                    {
                        procInputBeforePSR = procInputBeforePSR + xrBeforeStep[i];
                        xrBeforeStep[i] = xrBeforeStep[i + 1]; //Shifter
                    }
                    procInputBeforePSR = procInputBeforePSR / filtnb;

                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(w, val, cbDisplayW.Checked,t0rtc);
                    Application.DoEvents();

                }
                if (recOn)  // here continuous mode, stop only after Stop button
                {
                    buttonRSR.Enabled = false;
                    butProcStepResp.Enabled = false;
                    if (indexRec < pulse)
                    {
                        if (rbSignalAtW.Checked) { w = uoff + amp; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ1.Checked) { w = uoff; z1 = amp; z2 = 0; }
                        if (rbSignalAtZ2.Checked) { w = uoff; z1 = 0; z2 = amp; }
                    }
                    else
                    {
                        if (rbSignalAtW.Checked) { w = uoff; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ1.Checked) { w = uoff; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ2.Checked) { w = uoff; z1 = 0; z2 = 0; }
                    }
                    ProfAlgorithm();
                    indexRec++;
                    if (indexRec > (int)numPoints.Value)
                    {
                        indexRec = 0;
                    }
                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(w, val, cbDisplayW.Checked,t0rtc);
                    Application.DoEvents();

                }
            }
            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - dtstart);
            if (dt > dtmax) dtmax = dt;

            dtavr = dtavr + dt;
            cntT0++;
        }


        private void FormAdaptiveControl_FormClosing_1(object sender, FormClosingEventArgs e)
        {
            if (MMTimer1.Enabled == true)
            {
                MMTimer1.Disable();
            }
            e.Cancel = true;
            this.Visible = false;
            cbRealtimeDevice.Checked = false;
        }

        //timer 1 displays X ,Xr and W values
        private void timer1_Tick(object sender, EventArgs e)
        {
            labelX.Text = val.ToString("f3");
            labelXr.Text = youtDisplay.ToString("f3");
            labelW.Text = w.ToString("f3");
            labXFiltered.Text = youtdisplayfiltered.ToString("f3");
            toolStripStatusLabel1.Text = "i= " + minmax.progress.ToString();
            if (numPoints.Value > minmax.pts)
                tStripProgressBar1.Maximum = (int)numPoints.Value;
            else
                tStripProgressBar1.Maximum = minmax.pts;
            tStripProgressBar1.Value = minmax.progress;
        }

        //timer 2 displays t0,dT and dTMAX values
        private void timer2_Tick(object sender, EventArgs e)
        {
            if (cntT0 > 0)
            {
                double t0avr1 = t0avr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labelT0.Text = t0avr1.ToString("f6");
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labeldT.Text = dtavr1.ToString("f6");
                double dtmax1 = dtmax / (double)Stopwatch.Frequency * 1000;
                labeldTMAX.Text = dtmax1.ToString("f6");
                dtmax = 0; t0avr = 0; dtavr = 0; cntT0 = 0;
            }
        }


        private void buttonRUN_Click(object sender, EventArgs e)
        {
            int Tinterval = (int)numTimeInterval.Value;
            MMTimer1.Interval = (uint)numTimeInterval.Value;
            MMTimer1.Enabled = true;
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff);
            meinMain.ConvertToDouble(tbAmp.Text,ref amp);
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation);
              meinMain.ConvertToDouble(tbNoiseZ1.Text,ref NoiseAtZ1);

            if (recOn)
            {
                Int32.TryParse(tbPulse.Text, out pulse);
            }
            onRecord = false;
            z1 = 0; z2 = 0;
            yold = 0; yout = 0; xdold2 = 0; xdold1 = 0; yold2 = 0;
            yoldI = 0; xdn1casI = 0; youtI = 0; x1casI = 0;
            xdn1cas = 0; yout = 0; x1cas = 0;
            meinMain.DACoutput((short)nudChanDA.Value, 0);

            for (int i = 0; i < maxnp2; i++)
            { xd[i] = 0; xr[i] = 0; xa[i] = 0; }

            for (int i = 0; i < filtnb; i++) xrBeforeStep[i] = 0;
            procInputBeforePSR = 0;

            meinMain.ConvertToDouble(tbLimitation.Text,ref limitation);
            buttonStop.Enabled = true;
            butProcStepResp.Enabled = true;
            buttonRSR.Enabled = true;
            cntT0 = 0; t0avr = 0; dtavr = 0;
            timer1.Enabled = true;
            timer2.Enabled = true;
            cbDisplayW.Visible = true;
            cbDisplayW.Enabled = true;

             meinMain.ConvertToDouble(tbXroff.Text,ref xroff);
            if (rbInitialXroff.Checked)
            {
                w = xroff;
            }
            else
            {
                w = uoff;
            }
            RunOn = true;
        }

        private void buttonRSR_Click(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(tbUoff.Text,ref  uoff );
             meinMain.ConvertToDouble(tbXroff.Text,ref xoff );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp );
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation );
            //if (rbSignalAtW.Checked)
            //{
            //    w = uoff + amp;
            //    z1 = 0;
            //    z2 = 0;
            //}
            //if (rbSignalAtZ1.Checked)
            //{
            //    w = uoff;
            //    z1 = amp;
            //    z2 = 0;
            //}
            //if (rbSignalAtZ2.Checked)
            //{
            //    w = uoff;
            //    z2 = amp;
            //    z1 = 0;
            //}


            thisdrawnum = 0;
            if (cbDisplayW.Checked) thisdrawnum++;
            if (cbDisplayX.Checked) thisdrawnum++;
            if (cbDisplayXr.Checked) thisdrawnum++;
            if (thisdrawnum == 0)
            {
                cbDisplayX.Checked = true;  // at least one curve
                MessageBox.Show(OneCurvenecessary);
                thisdrawnum = 1;
            }
            LOrtc.toptitle = FilterName + "  " + numPoints.Value.ToString() + "  " + points;

            cbDisplayW.Enabled = true;
            tStripProgressBar1.Maximum = minmax.pts;//(int)numPoints.Value;
            tStripProgressBar1.Visible = true;
            onRecord = true;
            procSR = false;
        }

        private void butProcStepResp_Click(object sender, EventArgs e)
        {  // Measure the process step response
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff  );
             meinMain.ConvertToDouble(tbXroff.Text,ref xoff );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp );
             meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation);

            //w = amp;   // Only Amplitude is given to process input without offset
            //z1 = 0;
            //z2 = 0;
            cbDisplayW.Visible = false;
            thisdrawnum = 0;
            cbDisplayW.Checked = false;  // is senseless here
            if (cbDisplayX.Checked) thisdrawnum++;
            if (cbDisplayXr.Checked) thisdrawnum++;
            if (thisdrawnum == 0)
            {
                cbDisplayX.Checked = true;  // at least one curve
                MessageBox.Show(OneCurvenecessary);
                thisdrawnum = 1;
            }
            LOrtc.toptitle = FilterName + "  " + numPoints.Value.ToString() + "  " + points;
            //axChartfx1.Visible = true;
            //axChartfx1.OpenDataEx(def.COD_VALUES, trail + thisdrawnum, (int)numPoints.Value);
            //axChartfx1.OpenDataEx(def.COD_XVALUES, trail + thisdrawnum, (int)numPoints.Value);

            onRecord = true;
            procSR = true;


        }


        private void buttonStop_Click(object sender, EventArgs e)
        {
            meinMain.DACoutput((short)nudChanDA.Value, 0);
            MMTimer1.Disable();
            timer1.Enabled = false;
            timer2.Enabled = false;
            RunOn = false;
            buttonStop.Enabled = false;
            butProcStepResp.Enabled = false;
            buttonRSR.Enabled = false;
            i = 0; indexRec = 0;
        }


        // Writing report to text box
        private void tsbWriteReport_Click(object sender, EventArgs e)
        {
            meinMain.frmsavecurve.RefToChart2D = chart2D1;
            if (meinMain.frmsavecurve.WindowState == FormWindowState.Minimized)
                meinMain.frmsavecurve.WindowState = FormWindowState.Normal;
            meinMain.frmsavecurve.Show();
            meinMain.frmsavecurve.BringToFront();
        }



        private void buttonPQenter_Click(object sender, EventArgs e)
        {
            switch (Ncon)
            {
                case 0://P
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0p  );
                    } break;
                case 1://PD
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0d );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1d);
                    } break;
                case 2:
                case 4://PI
                    {
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0n );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1n );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1n);
                    } break;
                case 3:
                case 5://PID
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1i );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[0].Value.ToString(),ref q2i );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1i );
                    } break;
                case 6://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.qv[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.pv[i] );
                        }
                    } break;
                case 7://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                             meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.q1v[i] );
                             meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.p1v[i] );
                        }
                    } break;
                case 8://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref  meinMain.fcontrdes.q2v[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.p2v[i] );
                        }
                    } break;

                case 9://cascaded
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0ac );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q0ic );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref q1ic );
                    } break;
                case 10://Twopoint Controller
                    {
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref TwoPointUp );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[1].Value.ToString(),ref TwoPointDown );
                    } break;

                case 11://PID free
                    {
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0f );
                         meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[0].Value.ToString(),ref q2f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[1].Value.ToString(),ref p2f );
                    } break;

            }
        }

        private void cbLimitation_CheckedChanged(object sender, EventArgs e)
        {
            if (cbLimitation.Checked)
            {
                label32.Visible = true;
                tbLimitation.Visible = true;
            }
            else
            {
                label32.Visible = false;
                tbLimitation.Visible = false;
            }
        }

        private void rsbHelp_Click(object sender, EventArgs e)
        {
            acinfo.Show();
        }

        private void rbPcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPcon.Checked)
            {
                Ncon = 0;
                ConType = "P";
                mgradCon = 1;
                pq2DataGrid();
            }
        }


        private void rbPDT1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPDT1con.Checked)
            {
                Ncon = 1;
                ConType = "PDT1";
                mgradCon = 2;
                pq2DataGrid();
            }
        }

        private void rbPIcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPIcon.Checked)
            {
                Ncon = 2;
                ConType = "PI";
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rbPIDT1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPIDT1con.Checked)
            {
                Ncon = 3;
                ConType = "PIDT1";
                mgradCon = 3;
                pq2DataGrid();

            }
        }

        private void rbAWU1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAWU1con.Checked)
            {
                Ncon = 4;
                ConType = "PI AWU";
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rbAWU2con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAWU2con.Checked)
            {
                Ncon = 5;
                ConType = "PID AWU";
                mgradCon = 3;
                pq2DataGrid();

            }
        }

        private void rbDBVcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbDBVcon.Checked)
            {
                Ncon = 6;
                ConType = "DB(V)";
                mgradCon = meinMain.fcontrdes._mgradcd + 1;
                pq2DataGrid();

            }
        }

        private void rbDBV1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbDBV1con.Checked)
            {
                Ncon = 7;
                ConType = "DB(V+1)";
                mgradCon = meinMain.fcontrdes._mgradcd + 2;
                pq2DataGrid();

            }
        }


        private void rbORcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbORcon.Checked)
            {
                ConType = "OR ";
                Ncon = 8;
                mgradCon = meinMain.fcontrdes._mgradcd + 1;
                pq2DataGrid();
            }
        }


        private void rbCascadedcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbCascadedcon.Checked)
            {
                ConType = "Casc ";
                Ncon = 9;
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rb2Pcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rb2Pcon.Checked)
            {
                ConType = "2P ";
                Ncon = 10;
                mgradCon = 1;
                pq2DataGrid();

            }
        }

        private void rbFreecon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbFreecon.Checked)
            {
                ConType = "Free ";
                Ncon = 11;
                mgradCon = 3;
                pq2DataGrid();
            }
        }

        void pq2DataGrid()
        {
            dataGridViewControllerPar.RowCount = mgradCon;
            for (int i = 0; i < mgradCon; i++)
            {
                dataGridViewControllerPar.Rows[i].Cells[0].Value = "0";
                dataGridViewControllerPar.Rows[i].Cells[1].Value = "0";
                dataGridViewControllerPar.Rows[i].HeaderCell.Value = i.ToString();
            }
            switch (Ncon)
            {
                case 0://P
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0p.ToString();
                    } break;
                case 1://PD
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0d.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1d.ToString();
                    } break;
                case 2:
                case 4://PI
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0n.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1n.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1n.ToString();
                    } break;
                case 3:
                case 5://PID
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0i.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1i.ToString();
                        dataGridViewControllerPar.Rows[2].Cells[0].Value = q2i.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1i.ToString();
                    } break;
                case 6://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = meinMain.fcontrdes.qv[i].ToString();
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = meinMain.fcontrdes.pv[i].ToString();
                        }
                    } break;
                case 7://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = meinMain.fcontrdes.q1v[i].ToString();
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = meinMain.fcontrdes.p1v[i].ToString();
                        }
                    } break;
                case 8://OR
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = meinMain.fcontrdes.q2v[i].ToString();
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = meinMain.fcontrdes.p2v[i].ToString();
                        }
                    } break;

                case 9://cascaded
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0ac.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q0ic.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = q1ic.ToString();
                    } break;
                case 10://Twopoint Controller
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = TwoPointUp.ToString();
                        dataGridViewControllerPar.Rows[0].Cells[1].Value = TwoPointDown.ToString();
                    } break;

                case 11://PID free
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0f.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1f.ToString();
                        dataGridViewControllerPar.Rows[2].Cells[0].Value = q2f.ToString();
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1f.ToString();
                        dataGridViewControllerPar.Rows[2].Cells[1].Value = p2f.ToString();
                    } break;

            }

        }


        private void rbInitialXr0_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXr0.Checked)
            {
                InitialType = 0;
            }
        }

        private void rbInitialXroff_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXroff.Checked)
            {
                InitialType = 1;
                label17.Show();
                tbXroff.Show();
            }
            else
            {
                label17.Visible = false;
                tbXroff.Visible = false;
            }
        }

        private void rbInitialUoffByP_CheckedChanged(object sender, EventArgs e)
        {  // selectable PI
            if (rbInitialUoffByP.Checked)
            {
                InitialType = 2;
                grBoxInitPI.Visible = true;
            }
            else
                grBoxInitPI.Visible = false;
        }

        private void rbInitialUoffByPI_CheckedChanged(object sender, EventArgs e)
        {   // Cascaded Controller for Breathing system
            if (rbInitialUoffByPI.Checked)
            {
                InitialType = 3;
            }
        }

        private void rbInitialXByCon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXByCon.Checked)
            {
                InitialType = 4;
            }
        }

        private void cbRealtimeDevice_CheckedChanged(object sender, EventArgs e)
        {
            if (cbRealtimeDevice.Checked)
            {
                meinMain.frmRTdevice.Show();
            }
            else
            {
                meinMain.frmRTdevice.Visible = false;
            }
        }

        //clear the last curve


        //changing the uoff using button Run time
        private void tbUoff_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                buttonRUN.PerformClick();
            }
        }

        private void rbRectContinous_CheckedChanged(object sender, EventArgs e)
        {
            if (rbRectContinous.Checked)
            {
                label8.Visible = true;
                tbPulse.Visible = true;
                recOn = true;
            }
            else
            {
                label8.Visible = false;
                tbPulse.Visible = false;
                recOn = false;
            }
        }

        private void rbStepAutostop_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStepAutostop.Checked)
            {
                stepOn = true;
            }
            else
            {
                stepOn = false;
            }
        }

        private void rBStud_CheckedChanged(object sender, EventArgs e)
        {
            if (rBStud.Checked)
            {
                rb2Pcon.Visible = false;
                rbAWU1con.Visible = false;
                rbAWU2con.Visible = true;
                rbCascadedcon.Visible = false;
                rbDBV1con.Visible = false;
                rbDBVcon.Visible = true;
                rbFreecon.Visible = false;
                rbORcon.Visible = false;
                butFreeContr.Visible = false;
            }
            else
            {
                rb2Pcon.Visible = true;
                rbAWU1con.Visible = true;
                rbAWU2con.Visible = true;
                rbCascadedcon.Visible = true;
                rbDBV1con.Visible = true;
                rbDBVcon.Visible = true;
                rbFreecon.Visible = true;
                rbORcon.Visible = true;
                butFreeContr.Visible = true;
            }
        }

        private void butFreeContr_Click(object sender, EventArgs e)
        {
            meinMain.fpidpq.Show();
            meinMain.fpidpq.BringToFront();
        }

        private void numTimeInterval_ValueChanged(object sender, EventArgs e)
        {
            t0rtc = (double)numTimeInterval.Value * 0.001;  // sampling time in sec
            if (meinMain.frmSimul.cBSync.Checked) meinMain.frmSimul.SpEdpT0.Value = numTimeInterval.Value;
        }


        void xr_db(ref double xrr, double[] p, double[] q, double[] xr, double[] xd, int m)
        {
            double hv;
            int i;
            /*Dead-Beat-controller standard*/
            /*automatically adapting ideal/real mode*/
            hv = 0;
            if (rbReal.Checked) for (i = 1; i <= m; i++) hv = hv + p[i] * xr[i + 1] + q[i] * xd[i];
            else for (i = 1; i <= m; i++) hv = hv + p[i] * xr[i] + q[i] * xd[i];
            xrr = hv + q[0] * xd[0];
        }


        void xr_db1(ref double xrr, double[] p, double[] q, double[] xr, double[] xd, int m)
        /*Dead-Beat-controller with 1. impulse=2. impulse, needs 1 step more */
        {  /*automatically adapting ideal/real mode*/
            double hv;
            int i;
            hv = 0;
            if (rbReal.Checked) for (i = 1; i <= (m + 1); i++) hv = hv + p[i] * xr[i + 1] + q[i] * xd[i];
            else for (i = 1; i <= (m + 1); i++) hv = hv + p[i] * xr[i] + q[i] * xd[i];
            xrr = hv + q[0] * xd[0];
        }


        void xr_or(ref double xrr, double[] p, double[] q, double[] xr, int m, double[] teta, double wil, double f3l, double xl)
        /*Orientierungsregler  only for real mode*/
        {
            double c, hv, hv2, xprae;
            int i;
            xa[0] = xl;
            hv = 0; hv2 = 0;
            for (i = 1; i <= m; i++) hv = hv + teta[i + m + 1];
            for (i = 1; i <= m; i++) hv2 = hv2 + teta[i] * xa[i] - teta[i + m + 1] * xr[i + 1];
            if (hv == 0) c = 10 * limitation; else c = (xl + hv2) / hv;
            if (c > 10 * limitation) c = 10 * limitation;
            if (c < -10 * limitation) c = -10 * limitation;
            xprae = 0;
            for (i = 1; i <= m; i++) xprae = xprae + teta[i + m + 1] * (xr[i] - c) - teta[i] * xa[i - 1];
            hv = q[1] * xprae;
            for (i = 2; i <= m; i++) hv = hv - p[i] * (xr[i - 1] - c) + q[i] * xa[i - 2];
            xrr = f3l * wil - c + hv;
            for (i = m; i > 0; i--) xa[i] = xa[i - 1];

        }

        private void toolStripButton18_Click(object sender, EventArgs e)
        {   // copy datat and close
            if (tbLastValuesX.Lines.Length > 10)
                meinMain.fregress.tsbReadRTC.Enabled = true;
            if ((tbLastValuesX.Lines.Length > 10) && (tBLastValuesXr.Lines.Length > 10))
                meinMain.frmlsoff.rtcDataOK = true;
            Hide();
        }

        private void toolStripButton19_Click(object sender, EventArgs e)
        {  // no copy
            Hide();
        }



        private void tsbClearX__Click_1(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
        }

        private void tsbSaveX__Click_1(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tbLastValuesX.Text);
                myStream1.Close();
            }
        }

        private void tsbReportX__Click_1(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
            tbLastValuesX.Visible = false;
            string str = "";
            int index;
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(ayval[index, 0].ToString() + " " + ayval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=ayval[index, 0].ToString() + " " + ayval[index, 1].ToString();
            tbLastValuesX.AppendText(str);
            tbLastValuesX.Visible = true;
        }

        private void tsbClearXr_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
        }

        private void tsbSaveXr_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBLastValuesXr.Text);
                myStream1.Close();
            }
        }

        private void tsbReportXr_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
            tBLastValuesXr.Visible = false;
            string str = ""; 
            int index;
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(axrval[index, 0].ToString() + " " + axrval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(axrval[index, 0].ToString() + " " + axrval[index, 1].ToString());
            // Last point without CRLF
            tBLastValuesXr.AppendText(str);
            tBLastValuesXr.Visible = true;
        }

        private void tsbClearW_Click(object sender, EventArgs e)
        {
            tBLastValuesW.Clear();
        }

        private void tsbsaveW_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBLastValuesW.Text);
                myStream1.Close();
            }
        }

        private void tsbReportW_Click(object sender, EventArgs e)
        {
            tBLastValuesW.Clear();
            tBLastValuesW.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(awval[index, 0].ToString() + " " + awval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(awval[index, 0].ToString() + " " + awval[index, 1].ToString());
            tBLastValuesW.AppendText(str);
            tBLastValuesW.Visible = true;
        }

        private void tabPage5x_Enter(object sender, EventArgs e)
        {
            tbLastValuesX.Visible = true;

        }

        private void rbImpulsAutostop_Click(object sender, EventArgs e)
        {
            if (rbImpulsAutostop.Checked)
            {
                label8.Visible = true;
                tbPulse.Visible = true;
            }
            else
            {
                label8.Visible = false;
                tbPulse.Visible = false;
            }
        }


        private void butSaveContr_Click(object sender, EventArgs e)
        {
            if (saveDialogCon.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveDialogCon.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tbBeforePQenter.Text);
                myStream1.Close();
            }

        }

        private void butLoadContr_Click(object sender, EventArgs e)
        {
            // Load *con file, copy to p-q values

            if (openFileDialogCon.ShowDialog() == DialogResult.OK)
            {
                tbBeforePQenter.Clear();
                StreamReader filestream = new StreamReader(openFileDialogCon.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    tbBeforePQenter.AppendText(line + CRLF);
                }
                filestream.Close();
                butAktivatepqChange_Click(sender, e);
            }
        }



        void ProfAlgorithm()
        {
            double xd0;
            if (rbReal.Checked)
            {
                meinMain.DACoutput((short)nudChanDA.Value, yout);
                youtDisplay = yout;
            }
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible

            xd0 = w - val - z2;
            xd[0] = xd0;
            switch (Ncon)
            {
                case 0: yout = q0p * xd0; break;  //P controller
                case 1: yout = q0d * xd0 + q1d * xdold1; break; //PDT1 controller
                case 2: yout = p1n * yold + q0n * xd0 + q1n * xdold1; break; //PI controller
                case 3: yout = p1i * yold + q0i * xd0 + q1i * xdold1 + q2i * xdold2; break;  //PIDT1 controller
                case 4:
                    {  // PI AWU 
                        yout = p1n * yold + q0n * xd0 + q1n * xdold1; ;  // PI
                        if (cbLimitation.Checked)
                            if ((yout < -limitation) || (yout > limitation))
                            {
                                yout = yout - (q0n + q1n) * xd0;  // Subtract I- part
                            }
                    } break;
                case 5:
                    {  // PID AWU   
                        yout = p1i * yold + q0i * xd0 + q1i * xdold1 + q2i * xdold2;
                        if (cbLimitation.Checked)
                            if ((yout < -limitation) || (yout > limitation))
                            {
                                yout = yout - (q0i + q1i + q2i) * xd0;  // Subtract I- part
                            }
                    } break;
                case 6: xr_db(ref yout, meinMain.fcontrdes.pv, meinMain.fcontrdes.qv, xr, xd, meinMain.fcontrdes._mgradcd); break; // DeadBeat v 
                case 7: xr_db1(ref yout, meinMain.fcontrdes.p1v, meinMain.fcontrdes.q1v, xr, xd, meinMain.fcontrdes._mgradcd); break; // Dead beat v+1
                case 8: xr_or(ref yout, meinMain.fcontrdes.p2v, meinMain.fcontrdes.q2v, xr,
                    meinMain.fcontrdes._mgradcd, meinMain.fcontrdes.tetacd, w, meinMain.fcontrdes.f3or, val); break; // predictive orienteering controller
                case 9:
                    {   // Cascaded controller  q0ak=30;q0ik=0.201;q1ik=-0.17; /
                        ncas = (val - x1cas) / t0rtc;  // speed by differentiating 
                        wncas = q0ac * xd0;    // outer P-controller  
                        xdncas = wncas - ncas;
                        yout = yold + q0ic * xdncas + q1ic * xdn1cas;   // PI-controller inner loop 
                        x1cas = val; xdn1cas = xdncas;
                        if (cbLimitation.Checked)
                        {
                            if (yout > limitation) yout = limitation;
                            if (yout < -limitation) yout = -limitation;
                        }

                    } break;
                case 10: if (xd0 > 0.0) yout = TwoPointUp; else yout = TwoPointDown; break; /* ZPR 2-point contr.*/
                case 11:
                    {  // PID AWU  free   
                        yout = p1f * yold + p2f * yold2 + q0f * xd0 + q1f * xdold1 + q2f * xdold2;
                        if ((cbLimitation.Checked) && (meinMain.fpidpq.cBAntiwindup.Checked))
                            if ((yout < -limitation) || (yout > limitation))
                            {
                                yout = p1f * yold + p2f * yold2 + q0fPD * xd0 + q1fPD * xdold1 + q2fPD * xdold2;// PD- Alg
                            }
                    } break;


                default: yout = q0p * xd0; break;  //P controller

            }
            yold2 = yold; yold = yout; xdold2 = xdold1; xdold1 = xd0;

            for (int hzp = meinMain.fcontrdes._mgradcd + 2; hzp > 1; hzp--)
            {
                xr[hzp] = xr[hzp - 1];
                xd[hzp] = xd[hzp - 1];
            } /* shifter */
            xr[1] = yout; xd[1] = xd[0];

            yout = yout + z1;

            if (yout > 0) yout = yout + DZcompensation; else yout = yout - DZcompensation; //Dead Zone compensation

            if (cbLimitation.Checked)
            {
                if (yout > limitation) yout = limitation;
                if (yout < -limitation) yout = -limitation;
            }

            if (rbIdeal.Checked)
            {
                meinMain.DACoutput((short)nudChanDA.Value, yout);
                youtDisplay = yout;
            }
        }


        private void butAktivatepqChange_Click(object sender, EventArgs e)
        {
            int nb = tbBeforePQenter.Lines.Length;
            string[] pList = new string[nb]; // temporary array to accelerate
            int i;
            pList = tbBeforePQenter.Lines;  // pointer pList to Textbox
            string[] outstr = new string[10];

            meinMain.datatools.Str2NString(pList[0], ref outstr, ' ');//P
             meinMain.ConvertToDouble(outstr[1], ref q0p );
            meinMain.datatools.Str2NString(pList[1], ref outstr, ' ');//PD
             meinMain.ConvertToDouble(outstr[1], ref q0d );
            meinMain.ConvertToDouble(outstr[2], ref q1d );
            meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');//PI
             meinMain.ConvertToDouble(outstr[1], ref q0n  );
            meinMain.ConvertToDouble(outstr[2], ref q1n );
            meinMain.ConvertToDouble(outstr[3], ref p1n);
            meinMain.datatools.Str2NString(pList[3], ref outstr, ' ');//PID
             meinMain.ConvertToDouble(outstr[1], ref q0i  );
             meinMain.ConvertToDouble(outstr[2], ref q1i );
            meinMain.ConvertToDouble(outstr[3], ref q2i );
             meinMain.ConvertToDouble(outstr[4], ref p1i);

            meinMain.datatools.Str2NString(pList[4], ref outstr, ' ');//DB(v)
            int graddb = Convert.ToInt32(outstr[1]);
            meinMain.fcontrdes._mgradcd = graddb - 1;
            for (i = 0; i < graddb; i++)
            {
                meinMain.datatools.Str2NString(pList[5 + i], ref outstr, ' ');//DB(v)
                meinMain.ConvertToDouble(outstr[0], ref meinMain.fcontrdes.qv[i] );
                meinMain.ConvertToDouble(outstr[1], ref meinMain.fcontrdes.pv[i] );
            }

            meinMain.datatools.Str2NString(pList[5 + graddb], ref outstr, ' ');//DB(v+1)
            int graddb1 = Convert.ToInt32(outstr[1]);
            for (i = 0; i < graddb1; i++)
            {
                meinMain.datatools.Str2NString(pList[6 + graddb + i], ref outstr, ' ');//DB(v+1)
                meinMain.ConvertToDouble(outstr[0], ref meinMain.fcontrdes.q1v[i] );
                meinMain.ConvertToDouble(outstr[1], ref meinMain.fcontrdes.p1v[i] );
            }

            int offs = graddb + graddb1;
            meinMain.datatools.Str2NString(pList[6 + offs], ref outstr, ' ');//OR
            int graddb2 = Convert.ToInt32(outstr[1]);
            for (i = 0; i < graddb2; i++)
            {
                meinMain.datatools.Str2NString(pList[7 + offs + i], ref outstr, ' ');//OR
                meinMain.ConvertToDouble(outstr[0], ref meinMain.fcontrdes.q2v[i]);
                meinMain.ConvertToDouble(outstr[1], ref meinMain.fcontrdes.p2v[i] );
            }
            offs = offs + graddb2;

            meinMain.datatools.Str2NString(pList[7 + offs], ref outstr, ' ');//cascaded
            meinMain.ConvertToDouble(outstr[1], ref q0ac );
            meinMain.ConvertToDouble(outstr[2], ref q0ic );
            meinMain.ConvertToDouble(outstr[3], ref q1ic );

            meinMain.datatools.Str2NString(pList[8 + offs], ref outstr, ' ');//twopoint
            meinMain.ConvertToDouble(outstr[1], ref TwoPointUp);
             meinMain.ConvertToDouble(outstr[2], ref TwoPointDown );

            meinMain.datatools.Str2NString(pList[9 + offs], ref outstr, ' ');//PID free
            meinMain.ConvertToDouble(outstr[1], ref q0f );
            meinMain.ConvertToDouble(outstr[2], ref q1f   );
             meinMain.ConvertToDouble(outstr[3], ref q2f);
            meinMain.ConvertToDouble(outstr[4], ref p1f  );
            meinMain.ConvertToDouble(outstr[5], ref p2f  );
            butAktivatepqChange.Visible = false;
        }

        private void tbBeforePQenter_TextChanged(object sender, EventArgs e)
        {
            butAktivatepqChange.Visible = true;
        }

        private void tBiniQ0_Leave(object sender, EventArgs e)
        {   // KT aus qi at PI
            double q0 = q0Init;
            meinMain.ConvertToDouble(tBiniQ0.Text, ref q0);
            double q1 = q1Init;
            meinMain.ConvertToDouble(tBiniQ1.Text, ref q1);
            tbIniKr.Text = (-q1).ToString();
            tBiniTn.Text = (t0rtc / (-q0 / q1 - 1)).ToString();
            q0Init = q0;
            q1Init = q1;
        }

        private void tbIniKr_Leave(object sender, EventArgs e)
        {
            double kr = 0;
            meinMain.ConvertToDouble(tbIniKr.Text,ref kr);
            double tn = 0;
            meinMain.ConvertToDouble(tBiniTn.Text,ref tn);
            q0Init = kr * (1 + t0rtc / tn);
            q1Init = -kr;
            tBiniQ0.Text = q0Init.ToString();
            tBiniQ1.Text = q1Init.ToString();
        }

        private void Tabs_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (Tabs.SelectedIndex == 6)
            {  // fill TB with all controllers
                tbBeforePQenter.Clear();
                tbBeforePQenter.Visible = false;
                tbBeforePQenter.AppendText("P " + q0p.ToString() + CRLF);
                tbBeforePQenter.AppendText("PD " + q0d.ToString() + " " + q1d.ToString() + CRLF);
                tbBeforePQenter.AppendText("PI " + q0n.ToString() + " " + q1n.ToString() + " " + p1n.ToString() + CRLF);
                tbBeforePQenter.AppendText("PID " + q0i.ToString() + " " + q1i.ToString() + " " + q2i.ToString() + " " + p1i.ToString() + CRLF);
                tbBeforePQenter.AppendText("DB(v) " + (meinMain.fcontrdes._mgradcd + 1).ToString() + CRLF);

                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 1); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.qv[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.pv[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("DB(v+1) " + (meinMain.fcontrdes._mgradcd + 2).ToString() + CRLF);

                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 2); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.q1v[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.p1v[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("OR " + (meinMain.fcontrdes._mgradcd + 1).ToString() + CRLF);
                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 1); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.q2v[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.p2v[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("cascaded " + q0ac.ToString() + " " + q0ic.ToString() + " " + q1ic.ToString() + CRLF);
                tbBeforePQenter.AppendText("Twopoint " + TwoPointUp.ToString() + " " + TwoPointDown.ToString() + CRLF);
                tbBeforePQenter.AppendText("PIDfree " + q0f.ToString() + " " + q1f.ToString() + " " + q2f.ToString() + " " + p1f.ToString() + " " + p2f.ToString());
                tbBeforePQenter.Visible = true;
                butAktivatepqChange.Visible = false;
            }
        }

        private void rbIdeal_CheckedChanged(object sender, EventArgs e)
        {
            meinMain.frmSimul.rbIdeal.Checked = rbIdeal.Checked;
        }

        private void rbReal_CheckedChanged(object sender, EventArgs e)
        {
            meinMain.frmSimul.rbReal.Checked = rbReal.Checked;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //MMTimer1.Disable();    
            //timer3Draw.Enabled = true;
            if (cbDisplayX.Checked)
            {
                LOrtc.legend = "X " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, ayval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayXr.Checked)
            {
                LOrtc.legend = "Xr " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, axrval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayW.Checked)
            {
                LOrtc.legend = "W " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, awval, (int)numPoints.Value, ref minmax, LOrtc);
            }


        }

        private void timer3Draw_Tick(object sender, EventArgs e)
        {

        }

        private void tsbClearAll_Click(object sender, EventArgs e)
        {
            chart2D1.clearAll();
            minmax.init();

        }

        private void TSBClearLast_Click(object sender, EventArgs e)
        {
            if (minmax.serie > 1)
            {
                chart2D1.clearLast();
                minmax.serie--;
            }
            else
            {
                chart2D1.clearAll();
                minmax.init();
            }
        }

        private void timerDraw_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timerDraw.Enabled = false;
            butdrawAgain_Click(sender, null);

        }

        private void butdrawAgain_Click(object sender, EventArgs e)
        {
            if (cbDisplayX.Checked)
            {
                LOrtc.legend = "X " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, ayval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayXr.Checked)
            {
                LOrtc.legend = "Xr " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, axrval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayW.Checked)
            {
                LOrtc.legend = "W " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, awval, (int)numPoints.Value, ref minmax, LOrtc);
            }

        }
    }
}
