﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp.small_tools
{
    public partial class FormPIDMagPhase : Form
    {
        FormMain meinMain;
        public FormPIDMagPhase(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        double Dw_start;

        private void labelMag_Click(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void Efstart_Leave(object sender, EventArgs e)
        {
            double EFSTART=Dw_start/ 2.0 / Math.PI;
            meinMain.ConvertToDouble(Efstart.Text,ref EFSTART );
            Dw_start = EFSTART * 2.0 * Math.PI;
            Ewstart.Text = Dw_start.ToString("G10");
            Elogw.Text = Math.Log10(Dw_start).ToString("G10");
            buttonCalc_Click(sender, e);

        }

        private void Elogw_Leave(object sender, EventArgs e)
        {
            double ln10 = Math.Log(10);
            double dElogw = Math.Log10(Dw_start);
            meinMain.ConvertToDouble(Elogw.Text, ref dElogw);
            Dw_start = Math.Exp(dElogw * ln10);
            Efstart.Text = (Dw_start / 2.0 / Math.PI).ToString("G10");
            Ewstart.Text = Dw_start.ToString("G10");
            buttonCalc_Click(sender, e);

        }

        private void Ewstart_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Ewstart_Leave(sender, e);

        }

        private void Ewstart_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Ewstart.Text, ref Dw_start);
            Efstart.Text = (Dw_start / 2.0 / Math.PI).ToString("G10");
            Elogw.Text = Math.Log10(Dw_start).ToString("G10");
            buttonCalc_Click(sender, e);

        }

        private void Efstart_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Efstart_Leave(sender, e);

        }

        private void Elogw_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Elogw_Leave(sender, e);

        }

        private void buttonCalc_Click(object sender, EventArgs e)
        {
            double Kr = 1;
            double Tn = 0;
            double Tv = 0;
            double st = 1;
            double phi;
            meinMain.ConvertToDouble(textBoxKR.Text,ref Kr);
            meinMain.ConvertToDouble(textBoxTN.Text,ref Tn);
            meinMain.ConvertToDouble(textBoxTV.Text,ref Tv );
            meinMain.ConvertToDouble(textBoxST.Text,ref st );
            labelMag.Text = (Kr * Math.Sqrt(1 + (Dw_start * Tn) * (Dw_start * Tn)) * Math.Sqrt(1 + (Dw_start * Tv) * (Dw_start * Tv)) / Dw_start /Tn/ Math.Sqrt(1 + (Dw_start * Tv / st) * (Dw_start * Tv / st))).ToString("g5");
            phi = (-Math.PI/2.0 + Math.Atan(Dw_start * Tn) + Math.Atan(Dw_start * Tv) - Math.Atan(Dw_start * Tv / st));
            labelPhase.Text = (phi * 180 / Math.PI).ToString("g5");
        }

        private void FormPIDMagPhase_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();

        }
    }
}
